<!DOCTYPE html>
<html class="writer-html5" lang="en">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>nl2declare.constructs.declare_constraint &mdash; NL2Declare  documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css" />

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            NL2Declare
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../modules.html">nl2declare</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">NL2Declare</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../../nl2declare.html">nl2declare</a></li>
      <li class="breadcrumb-item active">nl2declare.constructs.declare_constraint</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for nl2declare.constructs.declare_constraint</h1><div class="highlight"><pre>
<div class="viewcode-block" id="DeclareConstraint"><a class="viewcode-back" href="../../../nl2declare.constructs.html#nl2declare.constructs.declare_constraint.DeclareConstraint">[docs]</a><span></span><span class="k">class</span> <span class="nc">DeclareConstraint</span><span class="p">:</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">constraint_type</span><span class="p">,</span> <span class="n">action_a</span><span class="p">,</span> <span class="n">action_b</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">is_negative</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">type</span> <span class="o">=</span> <span class="n">constraint_type</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">action_a</span> <span class="o">=</span> <span class="n">action_a</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">action_b</span> <span class="o">=</span> <span class="n">action_b</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">is_negative</span> <span class="o">=</span> <span class="n">is_negative</span>

<div class="viewcode-block" id="DeclareConstraint.size"><a class="viewcode-back" href="../../../nl2declare.constructs.html#nl2declare.constructs.declare_constraint.DeclareConstraint.size">[docs]</a>    <span class="k">def</span> <span class="nf">size</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span> <span class="c1">#unary constraint: size 2, non-negative binary constraint: size 3, negative binary contraint: size 4</span>
        <span class="n">n</span> <span class="o">=</span> <span class="mi">2</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">action_b</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">n</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">is_negative</span><span class="p">:</span>
            <span class="n">n</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="k">return</span> <span class="n">n</span></div>

    <span class="k">def</span> <span class="fm">__str__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">action_b</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;Constraint [type=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">type</span><span class="si">}</span><span class="s2">, A=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">action_a</span><span class="si">}</span><span class="s2">]&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">is_negative</span><span class="p">:</span>
            <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;Constraint [type= NOT-</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">type</span><span class="si">}</span><span class="s2">, A=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">action_a</span><span class="si">}</span><span class="s2">, B=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">action_b</span><span class="si">}</span><span class="s2">]&quot;</span>
        <span class="k">return</span> <span class="sa">f</span><span class="s2">&quot;Constraint [type=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">type</span><span class="si">}</span><span class="s2">, A=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">action_a</span><span class="si">}</span><span class="s2">, B=</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">action_b</span><span class="si">}</span><span class="s2">]&quot;</span>

<span class="w">    </span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    for evaluation</span>
<span class="sd">    (check whether a discovered constraint matches the expected constraint -&gt; gold standard)</span>
<span class="sd">    &#39;&#39;&#39;</span>
<div class="viewcode-block" id="DeclareConstraint.equals_gs"><a class="viewcode-back" href="../../../nl2declare.constructs.html#nl2declare.constructs.declare_constraint.DeclareConstraint.equals_gs">[docs]</a>    <span class="k">def</span> <span class="nf">equals_gs</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">gsc</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">type</span><span class="p">()</span> <span class="o">==</span> <span class="n">gsc</span><span class="o">.</span><span class="n">type</span><span class="p">()</span>
            <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">are_equal</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">action_a</span><span class="p">(),</span> <span class="n">gsc</span><span class="o">.</span><span class="n">action_a</span><span class="p">())</span>
            <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">are_equal</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">action_b</span><span class="p">(),</span> <span class="n">gsc</span><span class="o">.</span><span class="n">action_b</span><span class="p">())</span>
        <span class="p">)</span></div>

<div class="viewcode-block" id="DeclareConstraint.are_equal"><a class="viewcode-back" href="../../../nl2declare.constructs.html#nl2declare.constructs.declare_constraint.DeclareConstraint.are_equal">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">are_equal</span><span class="p">(</span><span class="n">a</span><span class="p">,</span> <span class="n">gsa</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">gsa</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="o">==</span> <span class="n">a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span></div></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, Pia Halkour, Marc Ludevid Wulf, Julian Kofferath.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>